#ifndef __xmmsException_h__
#define __xmmsException_h__

#include "xmmsException.h"
#include <xmmsclient/xmmsclient++/exceptions.h>

#define XMMS_TRY try {
#define XMMS_CATCH \
  } catch (Xmms::result_error e) { \
    std::cout << "function failed: " << e.what() << std::endl; \
    return NS_ERROR_FAILURE; \
  } catch (Xmms::connection_error e) { \
    std::cout << "connection error: " << e.what() << std::endl; \
    return NS_ERROR_FAILURE; \
  } catch (Xmms::mainloop_running_error e) { \
    std::cout << "The function can't be called sync now" << std::endl; \
    return NS_ERROR_FAILURE; \
  } catch(...) { \
    std::cout << "unknown exception" << std::endl; \
    return NS_ERROR_FAILURE; \
  }

#endif

/*
    *  return the function, if test fails (also in release builds):
          o NS_ENSURE_TRUE / NS_ENSURE_FALSE (test boolean)
          o NS_ENSURE_SUCCESS (test nsresult)
          o NS_ENSURE_ARG_POINTER (check function input)
          o NS_ENSURE_ARG_MIN / NS_ENSURE_ARG_MAX / NS_ENSURE_ARG_RANGE (check function input) 
    * Assertion/break, if test fails (only in debug builds):
          o NS_ASSERTION and NS_PRECONDITION (they do the same, the latter is for function beginning) 
*/
