#include "xmmsMedialib.h"
#include "xmmsUtils.h"
#include "nsIFile.h"
//#include <xmmsclient/xmmsclient++/result.h>

NS_IMPL_ISUPPORTS1(xmmsMedialib, xmmsIMedialib)

xmmsMedialib::xmmsMedialib(const Xmms::Medialib& medialib)
 : mMedialib(medialib)
{
}

xmmsMedialib::~xmmsMedialib()
{
  /* destructor code */
}

/* void addURL (in string url, in boolean isEncoded, in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsMedialib::AddURL(const char *url, PRBool isEncoded, xmmsIResult *cb, xmmsIError *e)
{
    NS_ENSURE_ARG_POINTER(url);
    XMMS_TRY
    //VoidResult r;
    if (isEncoded)
        mMedialib.addEntryEncoded(url);
    else
        mMedialib.addEntry(url);
    // TODO async result
    return NS_OK;
    XMMS_CATCH
}

/* void addFile (in nsIFile file, in boolean recursive, in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsMedialib::AddFile(nsIFile *file, PRBool recursive, xmmsIResult *cb, xmmsIError *e)
{
    NS_ENSURE_ARG_POINTER(file);
    XMMS_TRY
    if (recursive)
    {
        nsCAutoString path;
        file->GetNativePath(path);
        mMedialib.pathImport(path.get());
        return NS_OK;
    }
    else
        return NS_ERROR_NOT_IMPLEMENTED;
    XMMS_CATCH
}

/* void rescan (in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsMedialib::Rescan(xmmsIResult *cb, xmmsIError *e)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getSongByURL (in wstring url, in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsMedialib::GetSongByURL(const PRUnichar *url, xmmsIResult *cb, xmmsIError *e)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getSongByID (in long id, in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsMedialib::GetSongByID(PRInt32 id, xmmsIResult *cb, xmmsIError *e)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeSong (in xmmsISong song, in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsMedialib::RemoveSong(xmmsISong *song, xmmsIResult *cb, xmmsIError *e)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
