#ifndef __xmmsResultWrapper_h__
#define __xmmsResultWrapper_h__

#include "xmmsIResult.h"
#include "xmmsIError.h"
#include <xmmsclient/xmmsclient++/result.h>
#include <xmmsclient/xmmsclient++/signal.h>
#include "nsIVariant.h"
#include "xpcexception.h"
#include "nsCOMPtr.h"
#include "nsComponentManagerUtils.h"

class xmmsResultWrapper
{
public:
    xmmsResultWrapper(nsCOMPtr<xmmsIResult> res, nsCOMPtr<xmmsIError> err)
     : mRes(res),
       mErr(err)
    {}
    bool error(const std::string& msg)
    {
        std::cout << "function failed (async) : " << msg << std::endl;
        nsCOMPtr<nsIXPCException> e = do_CreateInstance("@mozilla.org/js/xpc/Exception;1");
         // TODO error code
        e->Initialize(msg.c_str(), NS_ERROR_FAILURE, nsnull, nsnull, nsnull, nsnull);
        mErr->Error(e);
        return false;
    };

protected:
    nsCOMPtr<xmmsIResult> mRes;
    nsCOMPtr<xmmsIError> mErr;
};

class xmmsVoidResultWrapper : public xmmsResultWrapper
{
public:
    xmmsVoidResultWrapper(Xmms::VoidResult& r, nsCOMPtr<xmmsIResult> res, nsCOMPtr<xmmsIError> err)
      : xmmsResultWrapper(res, err),
        mR(r)
    {
        std::cout << "connecting xmmsclient++ result with xpcom result function" << std::endl;
        r.connect(Xmms::bind(&xmmsVoidResultWrapper::result, this));
        r.connectError(Xmms::bind(&xmmsResultWrapper::error, this));
        std::cout << "waiting for server to respond" << std::endl;
    };
    bool result()
    {
        std::cout << "function succeeded and returned" << std::endl;
        nsCOMPtr<nsIWritableVariant> value = do_CreateInstance(NS_VARIANT_CONTRACTID); // "@mozilla.org/variant;1"
        value->SetAsVoid();
        mRes->Succeeded(value);
        return false;
    };

protected:
    Xmms::VoidResult& mR;
};

#endif
